<script setup lang="ts">
import { ref, computed } from "vue";

const props = defineProps<{
  id: string;
  title: string;
  type: string;
  name: string;
  modelValue: string;
  placeholder: string;
  errorMsg?: string;
  validator?: (input: string) => boolean;
}>();

const emit = defineEmits<{
  (e: "update:modelValue", value: string): void;
}>();

const errorElementId = `${props.id}_error`;
const isError = computed(() =>
  Boolean(
    props.modelValue &&
      props.errorMsg &&
      props.validator &&
      !props.validator(props.modelValue)
  )
);

const showError = ref(false);

function handleInput(e: Event) {
  if (!(e.target instanceof HTMLInputElement)) {
    return;
  }

  if (!isError.value) {
    showError.value = false;
  }

  emit("update:modelValue", e.target.value);
}

function handleInputFocusOut() {
  if (isError.value) {
    showError.value = true;
  } else {
    showError.value = false;
  }
}
</script>

<template>
  <label :for="id" class="field">
    <span class="title">{{ title }}</span>
    <input
      class="input"
      :id="id"
      :type="type"
      :name="name"
      autocomplete="off"
      :placeholder="placeholder"
      :aria-desribedby="validator ? errorElementId : null"
      :value="modelValue"
      @input="handleInput"
      @focusout="handleInputFocusOut"
    />
    <span
      v-if="isError && showError"
      class="error"
      aria-live="assertive"
      :id="errorElementId"
    >
      {{ errorMsg }}
    </span>
  </label>
</template>

<style lang="scss" scoped>
.field {
  display: grid;
  row-gap: 1rem;
}

.input {
  height: 5.5rem;
  width: 100%;
  padding: 1.8rem;
  caret-color: currentcolor;
  overflow: hidden;
  border: 1px solid currentcolor;
  border-radius: 1.2rem;

  &:focus {
    outline: 0.3rem solid currentcolor;
  }

  &::placeholder {
    color: var(--color-grey-light);
  }
}

.error {
  color: var(--color-alert);
}
</style>
